"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * @Author: saber2pr
 * @Date: 2019-07-21 18:41:06
 * @Last Modified by: saber2pr
 * @Last Modified time: 2019-11-18 13:32:11
 */
var react_1 = __importDefault(require("react"));
var ul_1 = require("../ul");
require("./style.less");
var utils_1 = require("../../utils");
function Tree(_a) {
    var root = _a.from, render = _a.map, _b = _a.depth, depth = _b === void 0 ? 0 : _b, useBrowserHistory = _a.useBrowserHistory, basename = _a.basename, selectBtn = _a.selectBtn;
    var children = root.children;
    if (root)
        if (children) {
            var childNodes = children.map(function (node, key) { return (react_1.default.createElement("li", { className: "Tree-Li", key: key },
                react_1.default.createElement(Tree, { from: node, map: render, depth: depth + 1, selectBtn: selectBtn, useBrowserHistory: useBrowserHistory, basename: basename }))); });
            if (depth === 0)
                return react_1.default.createElement(react_1.default.Fragment, null, childNodes);
            if (root.path) {
                if (useBrowserHistory) {
                    var pathname = decodeURIComponent(window.location.pathname.replace(/^\//, ''));
                    var curPath = decodeURIComponent(("" + basename + root.path).replace(/^\//, ''));
                    root.expand = pathname.startsWith(curPath);
                }
                else {
                    root.expand = utils_1.getHash().startsWith(root.path);
                }
            }
            return (react_1.default.createElement(ul_1.Ul, { node: root, render: render, index: depth, selectBtn: selectBtn }, childNodes));
        }
        else {
            return render(root, depth);
        }
}
exports.Tree = Tree;
